// channeld.c
 
#include <ansi.h>
#include <net/dns.h>

#pragma save_binary

inherit F_CLEAN_UP;
 
mapping channels = ([
	"sys":	([	"msg_speak": HIB "itΡj%sR%s\n" NOR, "wiz_only": 1 ]),
	"wiz":	([	"msg_speak": HIY "iŮvj%sR%s\n" NOR,
				"msg_emote": HIY "iŮvj%s" NOR,
				"wiz_only": 1
			]),
	"gwiz":	([	"msg_speak": HIG "iڧŮvj%sR%s\n" NOR,
				"msg_emote": HIG "iڧŮvj%s\n" NOR,
				"wiz_only": 1, "intermud": GWIZ, "channel": "CREATOR",
				"filter": 1,
				"intermud_emote": 1 ]),
	"es":	([	"msg_speak": HIR "iFGơj%sR%s\n" NOR,
				"msg_emote": HIR "iFGơj%s" NOR,
				"intermud": GCHANNEL, "channel": "es",
				"filter": (: $1["MUDLIB"]=="Eastern Stories" :) ]),
	"twiz":	([	"msg_speak": HIW "ixWŮvj%sR%s\n" NOR,
				"msg_emote": HIW "ixWŮvj%s" NOR,
				"wiz_only":1, "intermud": GCHANNEL, "channel": "twiz",
				"filter": (: $1["HOSTADDRESS"][0..2]=="140" :) ]),
	"chat":	([	"msg_speak": HIC "ij%sR%s\n" NOR,
				"msg_emote": HIC "ij%s" NOR,
			 ]),
	"rumor":([	"msg_speak": HIM "ij%sR%s\n" NOR,
				"msg_emote": HIM "ij%s" NOR,
				"anonymous": "YH"
			]),
	"music":([	"msg_speak": WHT "i߲Ƽ֩j%s۵ۡR%s\n" NOR,
				"msg_emote": WHT "i߲Ƽ֩j%s" NOR
			 ]),
]);
 
void create()
{
	seteuid(getuid());	// This is required to pass intermud access check.
}
 
varargs int do_channel(object me, string verb, string arg, int emote)
{
	object *ob;
	string *tuned_ch, who;
 
 	if( verb== "" ) return 0;
 
	// Check if this is a channel emote.
	if( verb[<1] == '*' ) {
		emote = 1;
		verb = verb[0..<2];
	}
 
	if( !mapp(channels) || undefinedp(channels[verb]) )
		return 0;
 
	if( userp(me) && me->link() ) {
		if(channels[verb]["wiz_only"] && !wizardp(me) )
			return 0;
 
		// If we speaks something in this channel, then must tune it in.
		tuned_ch = me->link()->query("channels");
		if( !pointerp(tuned_ch) )
			me->link()->set("channels", ({ verb }) );
		else if( member_array(verb, tuned_ch)==-1 )
			me->link()->set("channels", tuned_ch + ({ verb }) );
 
		// Support of channel emote
		if( emote && !channels[verb]["intermud_emote"]) {
			string vb, emote_arg;
 
			if (!arg) 
				arg = (string)me->name()+"ݰ_Ӫ״IC\n";
			else {
				if( sscanf(arg, "%s %s", vb, emote_arg)!= 2 ) {
					vb = arg;
					emote_arg = "";
				}
				arg = EMOTE_D->do_emote(me, vb, emote_arg, 1);
				if(!arg)
					if(is_chinese(vb))
						arg=(string)me->name()+vb+" "+emote_arg+"\n";
					else
						return 0;
				if( channels[verb]["anonymous"] )
					arg = replace_string(arg, me->name(), channels[verb]["anonymous"]);
			}
		}
        if( arg==(string)me->query_temp("last_channel_msg") )
            return notify_fail("ΥWDܽФnƬۦPTC\n");
 
    }
 
	// Make the identity of speaker.
 
	if( channels[verb]["anonymous"] )
		who = channels[verb]["anonymous"];
	else if( userp(me) || !stringp(who = me->query("channel_id")) )
		who = me->query("name") + "(" + capitalize(me->query("id")) + ")";
 
	// Ok, now send the message to those people listening us.
 
	ob = filter_array( users(), "filter_listener", this_object(), channels[verb] );
	if( !arg ) arg = "...";
 
	if( emote ) {
		string msg;

		if( !channels[verb]["msg_emote"] )
			return notify_fail("oWD emoteC\n");
		// Support of old behavier of intermud emote.
		if( channels[verb]["intermud_emote"] ) arg = who + " " + arg;
 
		msg = sprintf( channels[verb]["msg_emote"], arg );
//		if( msg[<1] != '\n' ) msg += "\n";
		message( "channel:" + verb, msg, ob );
	} else
		message( "channel:" + verb,
			sprintf( channels[verb]["msg_speak"], who, arg ), ob );
 
	if( arrayp(channels[verb]["extra_listener"]) ) {
		channels[verb]["extra_listener"] -= ({ 0 });
		if( sizeof(channels[verb]["extra_listener"]) )
			channels[verb]["extra_listener"]->relay_channel(me, verb, arg);
	}
	
	if( !undefinedp(channels[verb]["intermud"])
	&&	base_name(me) != channels[verb]["intermud"] )
		channels[verb]["intermud"]->send_msg(
			channels[verb]["channel"], me->query("id"), me->name(1), arg, emote,
			channels[verb]["filter"] );
 
	if( userp(me) ) 
		me->set_temp("last_channel_msg", arg);
 
	return 1;
}
 
int filter_listener(object ppl, mapping ch)
{
	// Don't bother those in the login limbo.
	if( !environment(ppl) ) return 0;
	
	if( ch["wiz_only"] ) return wizardp(ppl);
	return 1;
}

// register_relay_channel()
//
// This function allows non-user objects like npcs, daemons, etc to sign-up
// a channel for listenin. The way non-user objects listening channels is
// via a mudlib apply function relay_channel().
 
void register_relay_channel(string channel)
{
	object ob;
 
	ob = previous_object();
	if( undefinedp(channels[channel]) || !ob) return;
	if( arrayp(channels[channel]["extra_listener"]) ) {
		if( member_array(ob, channels[channel]["extra_listener"]) >=0 ) return;
		channels[channel]["extra_listener"] += ({ ob });
	} else
		channels[channel]["extra_listener"] = ({ ob });
}
