// logind.c

#pragma save_binary

#include <ansi.h>
#include <command.h>
#include <login.h>

inherit F_CLEAN_UP;
inherit F_DBASE;

int wiz_lock_level = WIZ_LOCK_LEVEL;

string *user_race = ({ "human", "yenhold", "woochan", "jiaojao" });

string *banned_name = ({
	"A", "p", "", "L", "o", "e", "",
	"wupS",
	"R", 
});

string *banned_site = ({
	"140.127.86.250",
	"140.128.1.%*d",
	"140.128.99.50",
	"140.128.122.%*d",
	"140.129.%*d",
	"192.192.140.%*d",
	"192.192.141.%*d",
	"192.192.190.9",
});

// This is a option to give penalty to those create character again and
// again to get 'good' attributes.
#ifdef ANTI_BUZZER
mapping buzzer_player = ([]);
mapping buzzer_ip = ([]);
string *penalty_attr = ({ "str", "int", "dex", "con", "spi", "cps", "wis", "cor" });
#endif

private void get_id(string arg, object ob);
private void confirm_id(string yn, object ob);
private void get_email(string email, object ob);
object make_body(object ob);
private void init_new_body(object link, object user);
varargs void enter_world(object ob, object user, int silent);
varargs void reconnect(object ob, object user, int silent);
object find_body(string name);
int check_legal_id(string arg);
int check_legal_name(string arg);
private int list_user_race(object link);

void create() 
{
	seteuid(getuid());
	set("channel_id", "suF");
}

void logon(object ob)
{
	object *usr;
	int i, wiz_cnt, ppl_cnt, login_cnt;

#ifdef ANTI_BUZZER
	if( buzzer_ip[query_ip_number(ob)] >= 10 ) {
		write("qzDгyHӦhFMzDNQڵӤ@qɶC\n");
		destruct(ob);
		return;
	}
#endif

	write(read_file(WELCOME));
	UPTIME_CMD->main();

	usr = users();
	wiz_cnt = 0;
	ppl_cnt = 0;
	login_cnt = 0;
	for(i=0; i<sizeof(usr); i++) {
		if( !environment(usr[i]) ) login_cnt++;
		else if( wizardp(usr[i]) ) wiz_cnt++;
		else ppl_cnt++;
	}
	printf("ثe@ %d ŮvB%d 쪱abuWMH %d ϥΪ̹ճsuC\n\n",
		wiz_cnt, ppl_cnt, login_cnt );

	write("z^WrR");
	input_to( (: get_id :), ob );
}

private void get_id(string arg, object ob)
{
	object ppl;

	arg = lower_case(arg);
	if( !check_legal_id(arg)) {
		write("z^WrR");
		input_to("get_id", ob);
		return;
	}
	ob->set("id", arg);
	seteuid(arg);
	export_uid(ob);
	seteuid(getuid());

#ifdef MAX_USERS
	if( wizhood(arg)=="(player)" && sizeof(users()) >= MAX_USERS ) {
		ppl = find_body(arg);
		// Only allow reconnect an interactive player when MAX_USERS exceeded.
		if( !ppl || !interactive(ppl) ) {
			write("藍_M" + MUD_NAME + "ϥΪ̤wgӦhFMЫݷ|AӡC\n");
			destruct(ob);
			return;
		}
	}
#endif

#ifdef ENABLE_BAN_SITE
	if( wizhood(arg)=="(player)" ) {
		int i;
		string ip;

		ip = query_ip_number(ob);
		for(i=0; i<sizeof(banned_site); i++)
			if( (ip == banned_site[i])
			||	sscanf(ip, banned_site[i])) {
				write("藍_Mz IP Address ثeQCڵsuaϡC\n");
				destruct(ob);
				return;
			}
	}
#endif

	if( wiz_level(arg) < wiz_lock_level ) {
		write("藍_M" + MUD_NAME + "ثeŮv " + WIZ_LOCK_LEVEL
			+ " HWH~suC\n");
		destruct(ob);
		return;
	}
	
	if( arg=="guest" ) {
		// If guest, let them create the character.
		get_email( "guest@" + query_ip_name(ob), ob);
		return;
	} else if( file_size(ob->query_save_file() + __SAVE_EXTENSION__) >= 0 ) {
		if( ob->restore() ) {
			write("пJKXR");
			input_to("get_passwd", 1, ob);
			return;
		}
		write("藍_MzHxsץXF@ǰDMЧQ guest HqŮvBzC\n");
		destruct(ob);
		return;
	}

	write("ϥ " + (string)ob->query("id") + " oӦWrN|гy@ӷsHMzTw(y/n)S");
	input_to("confirm_id", ob);
}

private void get_passwd(string pass, object ob)
{
	string my_pass;
	object user;

	write("\n");
	my_pass = ob->query("password");
	if( crypt(pass, my_pass) != my_pass ) {
		write("KX~T\n");
		destruct(ob);
		return;
	}

	// Check if we are already playing.
	user = find_body(ob->query("id"));
	if (user) {
		if( !user->link() ) {
			reconnect(ob, user);
			return;
		}
		write("znNt@ӳsuۦPHXhMӥNܡS(y/n)");
		input_to("confirm_relogin", ob, user);
		return;
	}

	if( objectp(user = make_body(ob)) ) {
		if( user->restore() ) {
			log_file( "USAGE", sprintf("[%s] %12s login from %s\n",
				ctime(time()), (string)user->query("id"),
				query_ip_name(ob) ) );
			enter_world(ob, user);
			return;
		} else 
			destruct(user);
	}
	write("бzsгyoӤHC\n");
	get_email(ob->query("email"), ob);
}

private void confirm_relogin(string yn, object ob, object user)
{
	object old_link;

	if( yn=="" ) {
		write("znNt@ӳsuۦPHXhMӥNܡS(y/n)");
		input_to("confirm_relogin", ob, user);
		return;
	}	

	if( yn[0]!='y' && yn[0]!='Y' ) {
		write("naMwUAӡC\n");
		destruct(ob);
		return;
	} else {
		tell_object(user, "HqOB( " + query_ip_number(ob)
			+ " )suNAұHC\n");
		log_file( "USAGE", sprintf("%s is replaced by %s (%s)\n", (string)user->query("id"),
			query_ip_name(ob), ctime(time()) ) );
	}

	// Kick out tho old player.
	old_link = user->link();
	if( old_link ) {
		exec(old_link, user);
		destruct(old_link);
	}

	reconnect(ob, user);	
}

private void confirm_id(string yn, object ob)
{
	if( yn=="" ) {
		write("ϥγoӦWrN|гy@ӷsHMzTw(y/n)S");
		input_to("confirm_id", ob);
		return;
	}	

	if( yn[0]!='y' && yn[0]!='Y' ) {
		write("naMЭsJz^WrR");
		input_to("get_id", ob);
		return;
	}

#ifdef ANTI_BUZZER
	if( buzzer_player[ob->query("id")] ) buzzer_player[ob->query("id")]++;
	else buzzer_player[ob->query("id")] = 1;
	if( buzzer_ip[query_ip_number(ob)] ) buzzer_ip[query_ip_number(ob)]++;
	else buzzer_ip[query_ip_number(ob)] = 1;
#endif
	write("г]wzKXR");
	input_to("new_password", 1, ob);
}

private void new_password(string pass, object ob)
{
	write("\n");
	if( strlen(pass)<5 ) {
		write("KXצܤ֭nӦrMЭ]zKXR");
		input_to("new_password", 1, ob);
		return;
	}
	ob->set("password", crypt(pass,0) );
	write("ЦAJ@zKXMHT{zSOR");
	input_to("confirm_password", 1, ob);
}

private void confirm_password(string pass, object ob)
{
	string old_pass;

	write("\n");
	old_pass = ob->query("password");
	if( crypt(pass, old_pass)!=old_pass ) {
		write("z⦸JKXä@ˡMЭs]w@KXR");
		input_to("new_password", 1, ob);
		return;
	}

	write("zqlla}R");
	input_to("get_email",  ob);
}

private void get_email(string email, object ob)
{
	ob->set("email", email);

	// Complete non-body-specific initialization of new user here.
	ob->set("karma", 20);

	list_user_race(ob);
	input_to("get_race", ob);
}

private void get_race(string race, object ob)
{
	int kar;

	if( member_array(race, user_race)==-1 ) {
		write("SoغرڡMЧAsܡR");
		input_to("get_race", ob);
		return;
	}

	kar = (int)RACE_D(race)->query("karma");
	if( wizhood(ob)=="(player)" && (int)ob->query("karma") < kar ) {
		write("A~OMЧAsܡR");
		input_to("get_race", ob);
		return;
	}
	ob->add("karma", -kar);

	write("zntk(m)Τk(f)S");
	input_to("get_gender", ob, race);
}

private void get_gender(string gender, object ob, string race)
{
	object body;
	string body_file;

	if( gender=="" ) {
		write("zntk(m)Τk(f)S");
		input_to("get_gender", ob, body);
		return;
	}

	if( gender[0]=='m' || gender[0]=='M' )		gender = "male";
	else if( gender[0]=='f' || gender[0]=='F' )	gender = "female";
	else {
		write("藍_Mzuܨk(m)Τk(f)R");
		input_to("get_gender", ob, body);
		return;
	}

	if( !stringp(body_file = RACE_D(race)->query("default_body")) )
		body_file = USER_OB;
	ob->set("body", body_file);
	if( !(body = make_body(ob)) ) {
		destruct(ob);
		return;
	}

	body->set("gender", gender);
	body->set_race(race);
	init_new_body(ob, body);
	// Remember it so we can dest it if we go linkdead before finishing
	// chraracter creation.
	ob->set_temp("temp_body", body);

	write("zWrR");
	input_to("get_name", ob, body);
}

private void get_name(string arg, object ob, object user)
{
	if( !check_legal_name(arg) ) {
		write("zWrR");
		input_to("get_name", ob, user);
		return;
	}

	ob->set("name", arg);
	user->set("name", arg);
	if( !ob->query("creation_time") ) {
		log_file( "USAGE", sprintf("%s was created from %s (%s)\n", user->query("id"),
			query_ip_name(ob), ctime(time()) ) );
		ob->set("creation_time", time());
	}
	enter_world(ob, user);
}

object make_body(object ob)
{
	string err;
	object user;
	int n;

	user = new(ob->query("body"));
	if(!user) {
		write("{bi঳HbקϥΪ̪󪺵{MLkiƻsC\n");
		write(err+"\n");
		return 0;
	}

	// When new connection is built, the login object is cloned with
	// uid = Root and euid = 0;
	seteuid(getuid(ob));
	export_uid(user);
	seteuid(getuid());
	user->set("id", ob->query("id"));
	user->set_name( ob->query("name"), ({ ob->query("id")}) );

	return user;
}

private void init_new_body(object link, object user)
{
#ifdef ANTI_BUZZER
	int penalty;
	string a;
#endif

	user->set("birthday", time() );
	user->set_class("commoner");
	user->set_level(1);
#ifdef ANTI_BUZZER
	penalty = buzzer_player[user->query("id")] - 1;
	if( penalty < buzzer_ip[query_ip_number(link)] )
		penalty = buzzer_ip[query_ip_number(link)];
	while(penalty-- > 0) {
		a = penalty_attr[random(sizeof(penalty_attr))];
		user->set_attr(a, user->query_attr(a)-1);
	}
#endif
	CHAR_D->setup_char(user);
}

varargs void enter_world(object ob, object user, int silent)
{
	object cloth, room;
	string startroom;

	user->set_link(ob);
	ob->set_body(user);
	exec(user, ob);

	if( !silent ) write("ثevR" + wizhood(user) + "\n");
	seteuid(getuid(user));
	user->setup();
	seteuid(getuid());

	// In case of new player, we save them here right aftre setup 
	// compeleted.
#ifdef SAVE_USER
	user->save();
#endif

/*
	cloth = new("/obj/cloth");
	cloth->move(user);
	cloth->wear();
*/

	if( !silent ) {
		cat(MOTD);
		if( ob->query("new_mail") ) {
			write( GRN + "\neiDARzHTШ毸Ӥ@...\n\n" + NOR);
			ob->set("new_mail", 0);
		}
		if( user->is_ghost() )
			startroom = DEATH_ROOM;
		else if( !stringp(startroom = user->query("startroom")) )
			startroom = START_ROOM;

		if( find_object(startroom) || !catch(startroom->foo()) )
			user->move(startroom);
		else {
			user->move(START_ROOM);
			startroom = START_ROOM;
			user->set("startroom", START_ROOM);
		}
		tell_room(startroom, user->query("name") + "suiJoӥ@ɡC\n",
			({user}));
		CHANNEL_D->do_channel( this_object(), "sys",
			sprintf("%s(%s)%ssuiJC",
				user->name(),
				user->query("id"),
				query_ip_name(user)) );
	}
}

varargs void reconnect(object ob, object user, int silent)
{
	user->set_link(ob);
	ob->set_body(user);
	exec(user, ob);

	user->reconnect();
	if( !silent ) {
		tell_room(environment(user), user->query("name") + "ssu^oӥ@ɡC\n",
		({user}));
	}
	CHANNEL_D->do_channel( this_object(), "sys",
		sprintf("%s(%s)%sssuiJC", user->query("name"), (string)user->query("id"),  query_ip_name(user)) );
}

void net_dead(object ob)
{
	CHANNEL_D->do_channel( this_object(), "sys",
		sprintf("%s(%s)_uFC", ob->name(), geteuid(ob)));
}

int check_legal_id(string id)
{
	int i;

	i = strlen(id);
	
	if( (strlen(id) < 3) || (strlen(id) > 12 ) ) {
		write("藍_MA^WrO 3  12 ӭ^rC\n");
		return 0;
	}
	while(i--)
		if( id[i]<'a' || id[i]>'z' ) {
			write("藍_MA^Wruέ^rC\n");
			return 0;
		}

	return 1;
}

int check_legal_name(string name)
{
	int i;

	i = strlen(name);
	
	if( (strlen(name) < 2) || (strlen(name) > 12 ) ) {
		write("藍_MAWrO 1  6 ӤrC\n");
		return 0;
	}
	while(i--) {
		if( name[i]<=' ' ) {
			write("藍_MAWrαrC\n");
			return 0;
		}
		if( i%2==0 && !is_chinese(name[i..<0]) ) {
			write("藍_MбzΡuvWrC\n");
			return 0;
		}
		if( name[i..i+1]=="@" ) {
			write("藍_MФnΪťզrWrC\n");
			return 0;
		}
	}
	if( member_array(name, banned_name)!=-1 ) {
		write("藍_MoئWr|yLHxZC\n");
		return 0;
	}

	return 1;
}

object find_body(string name)
{
	object ob, *body;

	if( objectp(ob = find_player(name)) )
		return ob;
	body = children(USER_OB);
	for(int i=0; i<sizeof(body); i++)
		if( clonep(body[i])
		&&	userp(body[i])			// the body should be once inhabited.
		&&	body[i]->is_character()	// or we might find the body in init phase.
		&&	getuid(body[i]) == name ) return body[i];

	return 0;
}

int set_wizlock(int level)
{
	if( wiz_level(this_player(1)) <= level )
		return 0;
	if( geteuid(previous_object()) != ROOT_UID )
		return 0;
	wiz_lock_level = level;
	return 1;
}

private int list_user_race(object link)
{
	string list;
	int race_cnt = 0;

	list = "A{b@ " + link->query("karma") + " I~OMiHܥHUرڡR\n\n";
	for(int i = sizeof(user_race)-1; i>=0; i--)
		if( RACE_D(user_race[i])->query("karma") <= (int)link->query("karma") ) {
			list += sprintf("%-25s %d I~O\n",
				to_chinese(user_race[i]) + "(" + user_race[i] + ")",
				RACE_D(user_race[i])->query("karma")
			);
			race_cnt++;
		}

	list += "\nAܡR";
	if( !race_cnt && (wizhood(link)=="(player)")) {
		write("A~OHgL@@غرڤFMUЦhhVOaC\n");
		return 0;
	}
	write(list);
	return 1;
}

void reincarnate(object ob)
{
	object link;

	seteuid(getuid());

	// If the user is linkdead, we'll wait until he reconnect or next time login.
	if( !(link = ob->link()) ) {
		ob->save();
		destruct(ob);
		return;
	}

	link->add("karma", ob->query_level());
	link->save();
	exec(link, ob);
	rm(ob->query_save_file() + __SAVE_EXTENSION__);
	destruct(ob);

	// The final death.
	if( !list_user_race(link) ) {
		write("A~OwgLFMҥHA_{@ɪa~WC\n");
		write("\n\n\nww բϢۢӡ@ݢӢ www\n\n\n");
		rm(link->query_save_file() + __SAVE_EXTENSION__);
		destruct(link);
		return;
	}

	input_to("get_race", link);
}

void reset()
{
#ifdef ANTI_BUZZER
	buzzer_player = ([]);
	buzzer_ip = ([]);
#endif
}
