// look.c

//#pragma optimize
#pragma save_binary

#include <room.h>
#include <ansi.h>

inherit F_CLEAN_UP;

int look_room(object me, object env);
int look_item(object me, object obj);
int look_living(object me, object obj);
int look_room_item(object me, string arg);

void create() {seteuid(getuid());}

int main(object me, string arg)
{
	object obj;
	int result;

	if( me->query_temp("block_msg/vision") )
		return notify_fail("A{b]ݤT\n");

	if( arg ) {
		if( (obj = present(arg, me))
		||	(obj = present(arg, environment(me)))) 
			if( obj->is_character() ) result = look_living(me, obj);
			else result = look_item(me, obj);
	}

	if( !result && environment(me) )
		return environment(me)->do_look(me, arg);
	return result;
}

int accept_object(object player, object item)
{
	return 1;
}

int look_item(object me, object obj)
{
	mixed *inv;

	write(obj->long());
	inv = all_inventory(obj);
	if( sizeof(inv) ) {
		inv = map_array(inv, "inventory_look", this_object() );
		message("vision", sprintf("̭R\n  %s\n",
			implode(inv, "\n  ") ), me);
	}
	return 1;
}

int look_living(object me, object obj)
{
	string str, limb_status, pro;
	mixed *inv;
	mapping my_fam, fam;

	if( me!=obj )
		message("vision", me->name() + "nۧAݡMDǤDNC\n", obj);

	str = obj->long();

	pro = (obj==me) ? gender_self(obj->query("gender")) : gender_pronoun(obj->query("gender"));

	if( (string)obj->query("race")=="H"
	&&	intp(obj->query("age")) )
		str += sprintf("%sݰ_Ӭ%shC\n", pro, chinese_number(obj->query("age") / 10 * 10));

	// If we both has family, check if we have any relations.
	if( obj!=me
	&&	mapp(fam = obj->query("family"))
	&&	mapp(my_fam = me->query("family")) 
	&&	fam["family_name"] == my_fam["family_name"] ) {
	
		if( fam["generation"]==my_fam["generation"] ) {
			if( (string)obj->query("gender") == "k" )
				str += sprintf( pro + "OA%s%sC\n",
					my_fam["master_id"] == fam["master_id"] ? "": "P",
					my_fam["enter_time"] > fam["enter_time"] ? "vS": "v");
			else
				str += sprintf( pro + "OA%s%sC\n",
					my_fam["master_id"] == fam["master_id"] ? "": "P",
					my_fam["enter_time"] > fam["enter_time"] ? "vj": "vf");
		} else if( fam["generation"] < my_fam["generation"] ) {
			if( my_fam["master_id"] == obj->query("id") )
				str += pro + "OAvC\n";
			else if( my_fam["generation"] - fam["generation"] > 1 )
				str += pro + "OAPC\n";
			else if( fam["enter_time"] < my_fam["enter_time"] )
				str += pro + "OAvBC\n";
			else
				str += pro + "OAvC\n";
		} else {
			if( fam["generation"] - my_fam["generation"] > 1 )
				str += pro + "OAP߽C\n";
			else if( fam["master_id"] == me->query("id") )
				str += pro + "OA̤lC\n";
			else
				str += pro + "OAvC\n";
		}
	}

	if( obj->query("max_kee") )
		str += pro + COMBAT_D->eff_status_msg((int)obj->query("eff_kee") * 100 / (int)obj->query("max_kee")) + "\n";

	inv = all_inventory(obj);
	if( sizeof(inv) ) {
		inv = map_array(inv, "inventory_look", this_object(), obj->is_corpse()? 0 : 1 );
		inv -= ({ 0 });
		if( sizeof(inv) )
			str += sprintf( obj->is_corpse() ? "%s򪫦R\n%s\n" : "%sWaۡR\n%s\n",
				pro, implode(inv, "\n") );
	}

	message("vision", str, me);

	if( obj!=me 
	&&	living(obj)
	&&	random((int)obj->query("bellicosity")/10) > (int)me->query("per") ) {
		write( obj->name() + "MLYA@C\n");
		COMBAT_D->auto_fight(obj, me, "berserk");
	}

	return 1;
}

string inventory_look(object obj, int flag)
{
	string str;

	str = obj->short();
	if( obj->query("equipped") )
		str = HIY "  " + str + NOR;
	else if( !flag )
		str = "    " + str;
	else
		return 0;

	return str;
}

int help (object me)
{
	write(@HELP
O榡: look [<~>|<ͪ>|<V>]
 
oӫOAdݧAҦbҡBY󪫫~BͪBάOVC
 
HELP
);
	return 1;
}
