// score.c

#include <ansi.h>
#include <combat.h>

inherit F_CLEAN_UP;

string bar_string = "";
string blank_string = "";

string display_attr(int gift, int value);
string status_color(int current, int max);
string tribar_graph(int val, int eff, int max);

void create() { seteuid(ROOT_UID); }

int main(object me, string arg)
{
	object ob;
	mapping score;
	string line, tmp, lform;
	int i;

	if(!arg) ob = me;
	else {
		ob = present(arg, environment(me));
		if (!ob) ob = find_player(arg);
		if (!ob) ob = find_living(arg);
		if (!ob) return notify_fail("Anݽ֪AS\n");
		if (!wizardp(me) && !ob->accept_info(me, "score") )
			return notify_fail("uŮvݧOHAC\n");
	}

	seteuid(getuid(ob));

	line = sprintf( BOLD "i %s j" NOR "%s\n\n", ob->rank(), ob->short(1) );
	line = sprintf("%s AO@%s%s %d %s%s%sM%s͡C\n\n", line,
		(tmp = ob->query("unit")) ? tmp : "",
		chinese_number(ob->query("age")),
		ob->query_level(),
		(tmp = ob->query("gender")) ? to_chinese(tmp) : "",
		to_chinese(ob->query_race()),
		ob->query("humanoid") ? ob->rank(0, 1) : "",
		CHINESE_D->chinese_date(((int)ob->query("birthday") - 14*365*24*60) * 60) );

	if( wizardp(me) || (int)me->query_level() > 1 ) {
		line = sprintf(
			"%s MO %s  x %s   %s  F %s\n"
			  " wO %s   %s  ڰ %s  z %s\n\n", line,
			display_attr(ob->query_attr("str",1), ob->query_attr("str")),
			display_attr(ob->query_attr("cor",1), ob->query_attr("cor")),
			display_attr(ob->query_attr("int",1), ob->query_attr("int")),
			display_attr(ob->query_attr("spi",1), ob->query_attr("spi")),
			display_attr(ob->query_attr("cps",1), ob->query_attr("cps")),
			display_attr(ob->query_attr("dex",1), ob->query_attr("dex")),
			display_attr(ob->query_attr("con",1), ob->query_attr("con")),
			display_attr(ob->query_attr("wis",1), ob->query_attr("wis")));
	}

	switch(ob->query("life_form")) {
		case "ghost":
			line += " A{bSM]SMuMC\n\n";
			break;
		case "living":
		default:
			line += " HUOA𯫪AM@ӪA 0 HUN|`C\n\n";
			break;
	}

	// Due the strange behavier of NCSA telnet, it occasionally missed the newline
	// right after ANSI control sequence NOR. So add a space before newline.
	if( ob->query_stat_maximum("gin") )
		line = sprintf("%s    %s%4d/%4d  " NOR GRN "%s\n" NOR, line,
			status_color(ob->query_stat("gin"), ob->query_stat_maximum("gin")),
			ob->query_stat("gin"),	ob->query_stat_maximum("gin"),
			tribar_graph(ob->query_stat("gin"),	ob->query_stat_effective("gin"), ob->query_stat_maximum("gin")) );
	if( ob->query_stat_maximum("kee") )
	line = sprintf("%s    %s%4d/%4d  " HIR "%s\n" NOR, line,
		status_color(ob->query_stat("kee"), ob->query_stat_maximum("kee")),
		ob->query_stat("kee"), ob->query_stat_maximum("kee"),
		tribar_graph(ob->query_stat("kee"),	ob->query_stat_effective("kee"), ob->query_stat_maximum("kee")) );
	if( ob->query_stat_maximum("sen") )
	line = sprintf("%s    %s%4d/%4d  " HIB "%s\n" NOR, line,
		status_color(ob->query_stat("sen"), ob->query_stat_maximum("sen")),
		ob->query_stat("sen"), ob->query_stat_maximum("sen"),
		tribar_graph(ob->query_stat("sen"),	ob->query_stat_effective("sen"), ob->query_stat_maximum("sen")) );

	line = sprintf("%s\n  %s%4d/%4d" NOR "\t\t %s%4d/%4d\n" NOR, line,
		status_color(ob->query_stat("food"), ob->query_stat_maximum("food")),
		ob->query_stat("food"), ob->query_stat_maximum("food"),
		status_color(ob->query_stat("water"), ob->query_stat_maximum("water")),
		ob->query_stat("water"), ob->query_stat_maximum("water") );

	score = ob->query("score");
	if( mapp(score) ) {
		string *c;
		int xp;
		line += "\n Hg/R\n";
		c = sort_array(keys(score), 1);
		for(i = 0; i < sizeof(c); i++)
			line += sprintf("   %-15s%6d %-8s%s",
				to_chinese(c[i]),
				score[c[i]],
				((xp = (int)ob->query_target_score(c[i]) - score[c[i]]) > 0) ? ("[" + xp + "]") : "",
				i%2 ? "\n" : "   " );
		if( i%2==1 ) line += "\n";
		line += "\n";
	}

	write(line);
	return 1;
}

string display_attr(int gift, int value)
{
	if( value > gift )
		return sprintf( HIC "%3d%5s" NOR, value, "(+" + (value - gift) + ")" );
	else if( value < gift )
		return sprintf( HIB "%3d%5s" NOR, value, "(" + (value - gift) + ")" );
	else
		return sprintf( CYN "%3d     " NOR, value);
}

string status_color(int current, int max)
{
	int percent;

	if( max ) percent = current * 100 / max;
	else percent = 100;

	if( percent > 100 ) return HIC;
	if( percent >= 90 ) return HIG;
	if( percent >= 60 ) return HIY;
	if( percent >= 30 ) return YEL;
	if( percent >= 10 ) return HIR;
	return RED;
}

string tribar_graph(int val, int eff, int max)
{
	if( !max ) return "";

	if( max <= 20 )
		return bar_string[0..val*2-1]
			+ ((eff > val) ? blank_string[val*2..eff*2-1] : "");
	else
		return bar_string[0..(val*20/max)*2-1]
			+ ((eff > val) ? blank_string[(val*20/max)*2..(eff*20/max)*2-1] : "");
}

int help(object me)
{
        write(@HELP
O榡 : score
           score <HW>                   (ŮvM)
 
oӫOiHܧA(p)ΫwH(tǪ)򥻸ơC
򥻸ƪ]wаѾ\ 'help setup'C
 
LORhp
HELP
    );
    return 1;
}
