// mudlist.c

#include <net/daemons.h>
#include <net/macros.h>

inherit F_CLEAN_UP;

#define	SYNTAX	"O榡Rmudlist [<Mud W>]\n"

int main(object me, string arg)
{
	mapping mud_list, mud_svc;
	mixed *muds;
	string output;
	int loop, size;
	int list_all = 0;

	if( !find_object(DNS_MASTER) )
		return notify_fail("FèSQJMХNFJC\n");

	//	Obtain mapping containing mud data
	mud_list = (mapping)DNS_MASTER->query_muds();

	// so we recognise ourselves as a DNS mud
	mud_svc = DNS_MASTER->query_svc() + ([ Mud_name() : 0 ]);

	if(!mud_list)
		return notify_fail( MUD_NAME + "ثeèSWL Mud opôC\n");

	//	Get list of all mud names within name server
	muds = keys( mud_list ) - ({ "DEFAULT" });

	//	Place mudlist into alphabetical format
	muds = sort_array(muds, 1);

	// 	If mudname provided, search server's database for a match
	//	and display its cooresponding address
	if(arg && arg != "")
		if( arg=="-a" )
			list_all = 1;
		else {
			arg = htonn(arg);

			if(!mapp( mud_list[arg] )) {
				write(MUD_NAME + "èSM \"" + arg + "\" opôC\n");
				return 1;
			}
			printf(" %s TR\n%O\n", arg, mud_list[arg]);
			return 1;
		}

	output = "Mud W\t\tں}\t      \tDNS\tES\n========\t\t============\t      ====\t===\t===\n";

	//	Loop through mud list and store one by one
	for(loop = 0, size = sizeof(muds); loop<size; loop++) {
		if( !list_all && mud_list[muds[loop]]["MUDLIB"] != "Eastern Stories" )
			continue;
		output += sprintf("%-24s%-18s%8s\t %s \t %s\n", muds[loop], 
			mud_list[muds[loop]]["HOSTADDRESS"],
			mud_list[muds[loop]]["PORT"],
			undefinedp(mud_svc[muds[loop]]) ? "" : "",
			mud_list[muds[loop]]["MUDLIB"] == "Eastern Stories" ? "" : "");
	}

	//	Display dumped mudlist output through user's more pager
	this_player()->start_more( output );

	return 1;
}

int help()
{
	write( SYNTAX + "\n"
		"oӫOACXثeo Mud opôL MudC\n"
	);
	return 1;
}

