// innkeeper.c

#include <localtime.h>
#include <npc.h>

inherit F_VILLAGER;

void open_inn();
void close_inn();

int on_business = 0;

void create()
{
	mapping gt;

	set_name("xd", ({ "innkeeper", "keeper" }) );
	set_race("human");
	set_level(4);

	set("age", 52);
	set("long", "oKOoaȴ̪xdMݰ_Ӻֺ֮OӦѦnHC\n");
	set("schedule", ([
		700: (: open_inn :),
		2200: (: close_inn :),
	]));
	setup();
	carry_money("coin", 160);

	gt = NATURE_D->game_time(1);
	if( gt[LT_HOUR] < 7 || gt[LT_HOUR] > 22 ) on_business = 0;
	else on_business = 1;
}

void init()
{
	::init();
	if( !is_fighting() )
		do_chat( (: command, "say wTwTи̭T" :) );
}

void relay_emote(object from_ob, string verb)
{
	command("smile");
}

int accept_fight(object player)
{
	do_chat((: command, "say o" + player->rank("respectful")
	 + "uR}MpѨ٭nͷNOC\n":));
	return 0;
}

void accept_kill(object player)
{
	object ob;

	if( is_fighting() ) return;

	command("emote jsRHMϩRT");
	ob = present("garrison");
	if( !ob ) {
		ob = new(__DIR__"patrol");
		ob->move(environment());
		tell_room(environment(), "ީxLťsnM]FLӡC\n");
	}

	ob->protect(this_object());
	ob->kill_ob(player);
}

void open_inn()
{
	command("emote FӨMDRΪunM}ͷNaC");
	environment()->open_door("east");
	environment()->open_door("west");
	environment()->set("no_fight", 1);
}

void close_inn()
{
	object ob;

	command("say .. GFMLaMUȭЦC");
	command("emote NAeXȴ̡C");
	environment()->close_door("east");
	environment()->close_door("west");
	environment()->set("no_fight", 0);
	foreach(ob in all_inventory(environment()) ) {
		if( ob==this_object()
		||	!ob->is_character()
		||	ob->id("snow_inn_waiter") ) continue;
		ob->move(environment()->query("exits/east"));
	}
}
