// team.c

#include <ansi.h>
#include <dbase.h>
#include <origin.h>
#include <command.h>

void do_chat(mixed);
object query_charge_target();
varargs int is_fighting(object);
void clean_up_enemy();
void reset_time_unit();

static object leader, *team;

int set_leader(object ob)
{
	if( ob==this_object() )
		error("set_leader: Cannot set this_object() as leader.\n");
	leader = ob;
}

object query_leader() { return leader; }

int follow_me(object ob, string dir)
{
	if( !living(this_object()) || !living(ob) || ob==this_object() ) return 0;
	if( (ob!=leader) && (ob!=query_charge_target()) ) return 0;

	clean_up_enemy();
	if( GO_CMD->main(this_object(), dir) ) return 1;
	if( userp(this_object()) ) {
		tell_object(this_object(), HIG "A" + ob->name() + "FC\n" NOR);
		return 0;
	} else { // NPC only
		reset_time_unit();
		do_chat((: command, "go " + dir :));
	}
}

int add_team_member(object ob)
{
	if( ob==this_object() ) return 0;

	if( arrayp(team) ) {
		if( member_array(ob, team)==-1 ) {
			team += ({ ob });
			for(int i=sizeof(team)-1; i>=0; i--)
				team[i]->set_team(team);
		} else
			return 0;
	} else {
		team = ({ this_object(), ob });
		ob->set_team(team);
	}
	return 1;
}

int is_team_leader()
{
	return arrayp(team) && team[0]==this_object();
}

int set_team(object *t)
{
	team = t;
}

varargs int dismiss_team(object ob)
{
	int i;

	if( !arrayp(team) ) return 0;
	
	if( !ob ) {
		if( team[0]==this_object() ) {
			for(i=1; i<sizeof(team); i++)
				team[i]->set_team(0);
		} else {
			for(i=0; i<sizeof(team); i++)
				team[i]->dismiss_team( this_object() );
		}
		team = 0;
	} else
		team -= ({ ob });

	return 1;
}

object *query_team()
{
	return team;
}

