// loginc.

#include <login.h>
#include <dbase.h>
#include <user.h>

inherit F_ALIAS;
inherit F_DBASE;
inherit F_SAVE;

#include <dbase_security.h>

void update_age();

static object my_body;
static int last_age_set;

void create()
{
	// This is for the case that we need to load LOGIN_D
	seteuid(getuid());
}

int clean_up()
{
	if( !my_body ) destruct(this_object());
	return 1;
}

// This is called by driver when connect() in master object returns
// a clone of this object as user's connection object.
void logon()
{
	set_temp("login_time", time());
	last_age_set = time();

	call_out( "time_out", LOGIN_TIMEOUT );
	if( load_object(LOGIN_D) ) {
		seteuid(0);		// Let LOGIN_D export proprt uid to us.
		LOGIN_D->logon( this_object() );
	}
	else destruct(this_object());
}

// Don't destruct(this_object()) in the net_dead() interactive apply or
// there'll be error message: Double call to remove_interactive()
void net_dead()
{
	remove_call_out("time_out");
	call_out( "time_out", 1 );
}

void time_out()
{
	object body;

	if( objectp(my_body) ) return;

	if( interactive(this_object()) )
		write("zbsuiJ򪺮ɶӤ[FMUQnAӧaC\n");

	// If we go linkdead before we finish character creation, destruct
	// the body as well. 
	if( objectp(body = query_temp("temp_body"))
	&&	!userp(body) )
		destruct(body);
	destruct(this_object());
}

// This is used by F_SAVE to determinethe file name to save our data.
string query_save_file()
{
	string id;

	id = query("id", 1);
	if( !stringp(id) ) return 0;
	return sprintf(DATA_DIR "login/%c/%s", id[0], id);
}

void receive_message(string type, string str)
{
	if( !interactive(this_object()) ) return;
	if( !str || type!= "write" ) return;
	receive(str);
}

void terminal_type(string term_type)
{
	set_temp("terminal_type", term_type);
}

int set_body(object body)
{
	if( geteuid(previous_object()) != ROOT_UID ) return 0;

	my_body = body;
	seteuid(getuid());
}

object body()
{
	return my_body;
}

void update_age()
{
	if( !last_age_set ) last_age_set = time();
	::add("time_aged", time() - last_age_set);
	last_age_set = time();
}

